<script setup lang="ts">
import type { BaseLink, BaseImage } from '@/types/base';
import { ChevronLgRight } from 'slippers-ui/icons';
import { ref, computed } from 'vue';

interface Cards {
  header: string;
  link: BaseLink;
  type: string;
  image: BaseImage;
}

interface ResourcesTabs {
  name: string;
  items: Cards[];
  config: {
    key: string;
  };
}

interface ResourcesTabsProps {
  header: string;
  tabs: ResourcesTabs[];
  button?: BaseLink;
  config: {
    theme?: string;
    id?: string;
  };
}

const props = defineProps<ResourcesTabsProps>();
const activeTab = ref<ResourcesTabs>(props.tabs[0]); // Initialize with first tab

const displayItems = computed(() => {
  if (props.tabs.length === 1) {
    return props.tabs[0].items;
  }
  return activeTab.value?.items || [];
});

const filterFeatures = (key: string) => {
  const activeTabArray = props.tabs.filter((tab) => tab.config.key === key);
  activeTab.value = activeTabArray[0];
};

// Initialize with first tab's key instead of hardcoded
filterFeatures(props.tabs[0].config.key);
</script>

<template>
  <section :id="config?.id" class="resources-tabs" :class="`resources-tabs--${config?.theme}`">
    <SlpContainer>
      <div class="header">
        <SlpTypography tag="h2" variant="heading2-bold"> {{ header }}</SlpTypography>
        <SlpButton
          v-if="button"
          :href="button.config.href"
          variant="tertiary"
          :data-ga-name="button.config.dataGaName"
          :data-ga-location="button.config.dataGaLocation"
          class="resources-block__button"
        >
          {{ button.text }}
          <SlpIcon class="slp-ml-8" :icon="ChevronLgRight" alt="" />
        </SlpButton>
      </div>
      <hr v-if="button" />
      <div>
        <header v-if="tabs.length > 1" class="resources-tabs__tabs">
          <button
            v-for="tab in tabs"
            :key="tab.name"
            :data-ga-name="`${tab.name.toLowerCase()} tab`"
            data-ga-location="resources"
            class="resources-tabs__tab"
            :class="{ selected: activeTab.config.key === tab.config.key }"
            @click="filterFeatures(tab.config.key)"
          >
            <SlpTypography tag="span" variant="body2-bold"> {{ tab.name }}</SlpTypography>
          </button>
        </header>
        <div>
          <SlpRow class="resources-tabs__cards slp-mb-96">
            <SlpColumn v-for="card in displayItems" :key="card.header" :cols="4">
              <CommonResourceCard v-bind="card"></CommonResourceCard>
            </SlpColumn>
          </SlpRow>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.header {
  align-items: center;
  @media (min-width: $breakpoint-md) {
    flex-direction: row;
    justify-content: space-between;
    display: flex;
  }
}
.resources-tabs {
  padding-top: 4.8rem;
  hr {
    margin: 32px 0px;
  }
  &__tabs {
    border-bottom: 2px solid $color-surface-200;
    margin: 48px 0;
  }
  &__tab {
    border: none;
    transition: all 0.3s ease;
    border-bottom: 2px solid transparent;
    box-shadow: 0 3px 0 0 transparent;
    padding: 0 24px 16px;
    cursor: pointer;
    &.selected {
      border-bottom: 2px solid $color-text-link-100;
      box-shadow: 0 3px 0 0 $color-text-link-100;
    }
  }
  &--dark {
    color: #fff;
    background-color: $color-primary-200;
    .resources-tabs__tab {
      color: #fff;
    }
  }
  &__cards {
    flex-wrap: nowrap;
    overflow: scroll;
    @media (min-width: $breakpoint-lg) {
      flex-wrap: wrap;
      overflow: auto;
    }
  }
}
</style>
